diff --git a/src/main/java/net/minecraft/core/item/JarItem.java b/src/main/java/net/minecraft/core/item/JarItem.java
index 55eb7b9fc..6ec22d8b3 100644
--- a/src/main/java/net/minecraft/core/item/JarItem.java
+++ b/src/main/java/net/minecraft/core/item/JarItem.java
@@ -74,7 +74,7 @@ public class JarItem extends PlaceableItem {
 
     public static boolean fillJar(Player player, ItemStack itemToGive){
         if(player.inventory.getCurrentItem().stackSize <= 1) {
-            player.inventory.setItem(player.inventory.currentItem, itemToGive);
+            player.inventory.setItem(player.inventory.getCurrentItemIndex(), itemToGive);
         } else {
         	player.inventory.insertItem(itemToGive, true);
         }
diff --git a/src/main/java/net/minecraft/core/item/PaintedDoorItem.java b/src/main/java/net/minecraft/core/item/PaintedDoorItem.java
index 3219b1b5a..2d451cb76 100644
--- a/src/main/java/net/minecraft/core/item/PaintedDoorItem.java
+++ b/src/main/java/net/minecraft/core/item/PaintedDoorItem.java
@@ -47,10 +47,10 @@ public class PaintedDoorItem extends DoorItem {
         }
         meta |= (15 - itemstack.getMetadata()) << 4 &0xF0;
 
-        world.editingBlocks = true;
+        world.noNeighborUpdate = true;
         world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, doorBlockBottom.id, meta);
         world.setBlockAndMetadataWithNotify(blockX, blockY + 1, blockZ, doorBlockTop.id, meta);
-        world.editingBlocks = false;
+        world.noNeighborUpdate = false;
         world.notifyBlocksOfNeighborChange(blockX, blockY, blockZ, doorBlockBottom.id);
         world.notifyBlocksOfNeighborChange(blockX, blockY + 1, blockZ, doorBlockTop.id);
         world.playBlockSoundEffect(entityplayer,blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, doorBlockBottom, EnumBlockSoundEffectType.PLACE);
diff --git a/src/main/java/net/minecraft/core/net/command/commands/CloneCommand.java b/src/main/java/net/minecraft/core/net/command/commands/CloneCommand.java
index c5d1a7170..1ca536007 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/CloneCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/CloneCommand.java
@@ -144,7 +144,7 @@ public class CloneCommand {
             throw INSIDE_CLONED_AREA.create();
         }
 
-        start.getWorld().editingBlocks = true;
+        start.getWorld().noNeighborUpdate = true;
         Map<IntegerCoordinates, ClonedBlock> map = new HashMap<>();
         for (int x = minX; x <= maxX; x++) {
             for (int y = minY; y <= maxY; y++) {
@@ -161,10 +161,10 @@ public class CloneCommand {
             }
         }
         if (!destination.getWorld().isBlockLoaded(destinationX, destinationY, destinationZ)) throw DESTINATION_NOT_LOADED.create();
-        start.getWorld().editingBlocks = false;
+        start.getWorld().noNeighborUpdate = false;
 
         int clonedBlocks = 0;
-        destination.getWorld().editingBlocks = true;
+        destination.getWorld().noNeighborUpdate = true;
         for (Map.Entry<IntegerCoordinates, ClonedBlock> entry : map.entrySet()) {
             int offsetDestinationX = destinationX + entry.getKey().getX(source);
             int offsetDestinationY = destinationY + entry.getKey().getY(source, true);
@@ -179,7 +179,7 @@ public class CloneCommand {
                 CommandHelper.setBlockEntity(destination.getWorld(), offsetDestinationX, offsetDestinationY, offsetDestinationZ, entry.getValue().getBlockEntity());
             }
         }
-        destination.getWorld().editingBlocks = false;
+        destination.getWorld().noNeighborUpdate = false;
         source.sendTranslatableMessage(clonedBlocks == 1 ? "command.commands.clone.success_single" : "command.commands.clone.success_multiple", clonedBlocks);
         return clonedBlocks;
     }
diff --git a/src/main/java/net/minecraft/core/net/command/commands/FillCommand.java b/src/main/java/net/minecraft/core/net/command/commands/FillCommand.java
index 0ef81bbe1..30490476a 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/FillCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/FillCommand.java
@@ -112,7 +112,7 @@ public class FillCommand {
     }
 
     public static int fillReplace(CommandSource source, World world, IntegerCoordinates first, IntegerCoordinates second, BlockInput block, @Nullable BlockInput filter, boolean destroy) throws CommandSyntaxException {
-        world.editingBlocks = true;
+        world.noNeighborUpdate = true;
         int minX = Math.min(first.getX(source), second.getX(source));
         int minY = Math.min(first.getY(source, true), second.getY(source, true));
         int minZ = Math.min(first.getZ(source), second.getZ(source));
@@ -140,13 +140,13 @@ public class FillCommand {
                 }
             }
         }
-        world.editingBlocks = false;
+        world.noNeighborUpdate = false;
 
         return blocksFilled;
     }
 
     public static int fillHollow(CommandSource source, World world, IntegerCoordinates first, IntegerCoordinates second, BlockInput block) throws CommandSyntaxException {
-        world.editingBlocks = true;
+        world.noNeighborUpdate = true;
         int minX = Math.min(first.getX(source), second.getX(source));
         int minY = Math.min(first.getY(source, true), second.getY(source, true));
         int minZ = Math.min(first.getZ(source), second.getZ(source));
@@ -170,13 +170,13 @@ public class FillCommand {
                 }
             }
         }
-        world.editingBlocks = false;
+        world.noNeighborUpdate = false;
 
         return blocksFilled;
     }
 
     public static int fillOutline(CommandSource source, World world, IntegerCoordinates first, IntegerCoordinates second, BlockInput block) throws CommandSyntaxException {
-        world.editingBlocks = true;
+        world.noNeighborUpdate = true;
         int minX = Math.min(first.getX(source), second.getX(source));
         int minY = Math.min(first.getY(source, true), second.getY(source, true));
         int minZ = Math.min(first.getZ(source), second.getZ(source));
@@ -199,7 +199,7 @@ public class FillCommand {
                 }
             }
         }
-        world.editingBlocks = false;
+        world.noNeighborUpdate = false;
 
         return blocksFilled;
     }
diff --git a/src/main/java/net/minecraft/core/net/handler/PacketHandler.java b/src/main/java/net/minecraft/core/net/handler/PacketHandler.java
index cffa6be0f..0d5d9d04c 100644
--- a/src/main/java/net/minecraft/core/net/handler/PacketHandler.java
+++ b/src/main/java/net/minecraft/core/net/handler/PacketHandler.java
@@ -243,6 +243,10 @@ public abstract class PacketHandler
         handleInvalidPacket(setEquippedItemPacket5Playerinventory);
     }
 
+    public void handlePlayerHeldObject(SetHeldObjectPacket setHeldObjectPacket) {
+        handleInvalidPacket(setHeldObjectPacket);
+    }
+
     public void handleTransaction(ContainerAckPacket containerAckPacket)
     {
         handleInvalidPacket(containerAckPacket);
diff --git a/src/main/java/net/minecraft/core/net/packet/AddPlayerPacket.java b/src/main/java/net/minecraft/core/net/packet/AddPlayerPacket.java
index 0e875ab74..91e537c1c 100644
--- a/src/main/java/net/minecraft/core/net/packet/AddPlayerPacket.java
+++ b/src/main/java/net/minecraft/core/net/packet/AddPlayerPacket.java
@@ -1,9 +1,11 @@
 package net.minecraft.core.net.packet;
 
+import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.Nullable;
 
 import java.io.*;
 import java.util.UUID;
@@ -33,6 +35,13 @@ public class AddPlayerPacket extends Packet
         currentItem = itemstack != null ? itemstack.itemID : 0;
         nickname = entityplayer.getDisplayName();
         chatColor = entityplayer.chatColor;
+        if (entityplayer.getHeldObject() == null) {
+            heldObjectTag = null;
+        } else {
+            CompoundTag tag = new CompoundTag();
+            entityplayer.getHeldObject().writeToNBT(tag);
+            heldObjectTag = tag;
+        }
     }
 
     @Override
@@ -50,6 +59,12 @@ public class AddPlayerPacket extends Packet
         currentItem = dis.readShort();
         nickname = readString(dis, 32);
         chatColor = dis.readByte();
+
+        if (dis.readByte() == 1) {
+            heldObjectTag = readCompressedCompoundTag(dis);
+        } else {
+            heldObjectTag = null;
+        }
     }
 
     @Override
@@ -67,6 +82,13 @@ public class AddPlayerPacket extends Packet
         dos.writeShort(currentItem);
         writeString(nickname, dos);
         dos.writeByte(chatColor);
+
+        if (heldObjectTag != null) {
+            dos.writeByte(1);
+            writeCompressedCompoundTag(heldObjectTag, dos);
+        } else {
+            dos.writeByte(0);
+        }
     }
 
     @Override
@@ -90,6 +112,7 @@ public class AddPlayerPacket extends Packet
     public byte rotation;
     public byte pitch;
     public int currentItem;
+    public @Nullable CompoundTag heldObjectTag;
     public String nickname;
     public byte chatColor;
 }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet.java b/src/main/java/net/minecraft/core/net/packet/Packet.java
index f771af942..bb5b4a064 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet.java
+++ b/src/main/java/net/minecraft/core/net/packet/Packet.java
@@ -273,6 +273,7 @@ public abstract class Packet
         addMapping(24, true, false, AddMobPacket.class);
         addMapping(25, true, false, AddPaintingPacket.class);
         addMapping(26, true, true, BoatControlPacket.class);
+        addMapping(27, true, true, SetHeldObjectPacket.class);
         addMapping(28, true, false, SetEntityMotionPacket.class);
         addMapping(29, true, false, RemoveEntityPacket.class);
         addMapping(30, true, false, MoveEntityPacket.class);
@@ -309,7 +310,7 @@ public abstract class Packet
         addMapping(105, true, false, ContainerSetDataPacket.class);
         addMapping(106, true, true, ContainerAckPacket.class);
         addMapping(107, false, true, UpdateCreativeInventoryPacket.class);
-        addMapping(108, false, true, SetHotbarOffsetPacket.class);
+        addMapping(108, true, true, SetHotbarOffsetPacket.class);
         addMapping(120, true, false, CommandManagerPacket.class);
         addMapping(121, false, true, RequestCommandManagerPacket.class);
         addMapping(130, false, true, SignUpdatePacket.class);
diff --git a/src/main/java/net/minecraft/core/net/packet/SetHeldObjectPacket.java b/src/main/java/net/minecraft/core/net/packet/SetHeldObjectPacket.java
new file mode 100644
index 000000000..f65a465e3
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/packet/SetHeldObjectPacket.java
@@ -0,0 +1,57 @@
+package net.minecraft.core.net.packet;
+
+import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.net.handler.PacketHandler;
+import net.minecraft.core.world.ICarriable;
+import org.jetbrains.annotations.Nullable;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class SetHeldObjectPacket extends Packet{
+    public int entityID;
+    public @Nullable CompoundTag objectTag;
+    public SetHeldObjectPacket() {
+
+    }
+
+    public SetHeldObjectPacket(int entityID, @Nullable ICarriable object) {
+        this.entityID = entityID;
+        if (object != null) {
+            CompoundTag tag = new CompoundTag();
+            object.writeToNBT(tag);
+            objectTag = tag;
+        }
+    }
+    @Override
+    public void read(DataInputStream dis) throws IOException {
+        entityID = dis.readInt();
+        if (dis.readByte() == 1) {
+            objectTag = readCompressedCompoundTag(dis);
+        } else {
+            objectTag = null;
+        }
+    }
+
+    @Override
+    public void write(DataOutputStream dos) throws IOException {
+        dos.writeInt(entityID);
+        if (objectTag != null) {
+            dos.writeByte(1);
+            writeCompressedCompoundTag(objectTag, dos);
+        } else {
+            dos.writeByte(0);
+        }
+    }
+
+    @Override
+    public void handlePacket(PacketHandler packetHandler) {
+        packetHandler.handlePlayerHeldObject(this);
+    }
+
+    @Override
+    public int getEstimatedSize() {
+        return 0;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/player/inventory/container/Container.java b/src/main/java/net/minecraft/core/player/inventory/container/Container.java
index e88398b1a..b4068a044 100644
--- a/src/main/java/net/minecraft/core/player/inventory/container/Container.java
+++ b/src/main/java/net/minecraft/core/player/inventory/container/Container.java
@@ -27,4 +27,8 @@ public interface Container
     boolean stillValid(Player entityplayer);
 
     void sortContainer();
+
+    default boolean locked(int index) {
+        return false;
+    }
 }
diff --git a/src/main/java/net/minecraft/core/player/inventory/container/Inventory.java b/src/main/java/net/minecraft/core/player/inventory/container/Inventory.java
index 53abeeead..541a829bd 100644
--- a/src/main/java/net/minecraft/core/player/inventory/container/Inventory.java
+++ b/src/main/java/net/minecraft/core/player/inventory/container/Inventory.java
@@ -26,6 +26,13 @@ import org.jetbrains.annotations.Nullable;
 public class Inventory
     implements Container
 {
+    protected int hotbarOffset = 0;
+    public ItemStack[] mainInventory;
+    public ItemStack[] armorInventory;
+    protected int currentItem;
+    public Player player;
+    private ItemStack heldItem;
+    public boolean inventoryChanged;
 
     public Inventory(Player player)
     {
@@ -36,6 +43,15 @@ public class Inventory
         this.player = player;
     }
 
+    public int getHotbarOffset() {
+        return hotbarOffset;
+    }
+
+    public void setHotbarOffset(int offset, boolean overrideLock) {
+        if (!overrideLock && currentItemLocked()) return;
+        hotbarOffset = offset;
+    }
+
     @Nullable
     public ItemStack getCurrentItem()
     {
@@ -47,6 +63,15 @@ public class Inventory
             return null;
         }
     }
+
+    public int getCurrentItemIndex() {
+        return currentItem;
+    }
+
+    public void setCurrentItemIndex(int index, boolean overrideLock) {
+        if (!overrideLock && currentItemLocked()) return;
+        currentItem = index;
+    }
     
     public static int func_25054_e()
     {
@@ -96,7 +121,9 @@ public class Inventory
     	for(int stage = 0; stage < 2; stage++) {
         	for(int i=0; i < mainInventory.length; i++) {
         		int slotId = useHotbarOffset ? (i + hotbarOffset) % mainInventory.length : i;
-        		
+
+                if (locked(slotId)) continue;
+
         		ItemStack stackInSlot = mainInventory[slotId];
         		
         		if(stage == 0) {
@@ -133,6 +160,7 @@ public class Inventory
 
     public int setCurrentItem(ItemStack itemstack, boolean flag)
     {
+        if (currentItemLocked()) return currentItem;
     	if (!flag) return currentItem;
     	
     	if (itemstack.itemID < Block.blocksList.length)
@@ -160,6 +188,7 @@ public class Inventory
 
     public void changeCurrentItem(int i)
     {
+        if (currentItemLocked()) return;
         if(i > 0)
         {
             i = 1;
@@ -201,7 +230,16 @@ public class Inventory
         }
         return true;
     }
-    
+
+    public boolean currentItemLocked() {
+        return player.getHeldObject() != null;
+    }
+
+    @Override
+    public boolean locked(int index) {
+        return currentItemLocked() && index == currentItem;
+    }
+
     @Override
 	public ItemStack removeItem(int index, int takeAmount)
     {
@@ -519,12 +557,4 @@ public class Inventory
 			inventory.armorInventory[i] = null;
 		}
 	}
-
-    public int hotbarOffset = 0;
-    public ItemStack[] mainInventory;
-    public ItemStack[] armorInventory;
-    public int currentItem;
-    public Player player;
-    private ItemStack heldItem;
-    public boolean inventoryChanged;
 }
diff --git a/src/main/java/net/minecraft/core/player/inventory/slot/Slot.java b/src/main/java/net/minecraft/core/player/inventory/slot/Slot.java
index 75beacaa6..490c9ef3d 100644
--- a/src/main/java/net/minecraft/core/player/inventory/slot/Slot.java
+++ b/src/main/java/net/minecraft/core/player/inventory/slot/Slot.java
@@ -36,6 +36,7 @@ public class Slot
 
 	public ItemStack remove(final int i)
 	{
+		if (container.locked(slot)) return null;
 		return container.removeItem(slot, i);
 	}
 
@@ -66,7 +67,7 @@ public class Slot
 
 	public boolean mayPlace(final ItemStack itemstack)
 	{
-		return true;
+		return container != null && !container.locked(slot);
 	}
 
 	public void onTake(final ItemStack itemstack)
@@ -99,11 +100,11 @@ public class Slot
 	}
 	
 	public boolean enableDragAndPickup() {
-		return true;
+		return !container.locked(slot);
 	}
 	
 	public boolean allowItemInteraction() {
-		return true;
+		return !container.locked(slot);
 	}
 
 	public boolean getIsDiscovered(Player player){
diff --git a/src/main/java/net/minecraft/core/world/BlocksContainer.java b/src/main/java/net/minecraft/core/world/BlocksContainer.java
new file mode 100644
index 000000000..be3934c8a
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/BlocksContainer.java
@@ -0,0 +1,156 @@
+package net.minecraft.core.world;
+
+import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.enums.LightLayer;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.chunk.ChunkCoordinates;
+import net.minecraft.core.world.season.SeasonManager;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Collection;
+import java.util.HashMap;
+import java.util.Map;
+
+public class BlocksContainer implements WorldSource {
+    public final World world;
+    private final Map<ChunkCoordinates, BlockEntry> blockEntryMap = new HashMap<>();
+    private Entity lightRefEntity = null;
+    public BlocksContainer(World world) {
+        this.world = world;
+    }
+
+    public void setLightReferenceEntity(Entity entity) {
+        this.lightRefEntity = entity;
+    }
+
+
+    public void setBlock(int x, int y, int z, int blockID, int blockMeta, BlockEntity entity) {
+        blockEntryMap.put(new ChunkCoordinates(x, y, z), new BlockEntry(blockID, blockMeta, entity, x, y, z));
+    }
+
+    public BlockEntry getEntry(int x, int y, int z) {
+        return blockEntryMap.get(new ChunkCoordinates(x, y, z));
+    }
+
+    public Collection<BlockEntry> getEntries() {
+        return blockEntryMap.values();
+    }
+
+    public void clear() {
+        blockEntryMap.clear();
+    }
+
+
+    @Override
+    public int getBlockId(int x, int y, int z) {
+        ChunkCoordinates c = new ChunkCoordinates(x, y, z);
+        if (blockEntryMap.containsKey(c)){
+            return blockEntryMap.get(c).blockID;
+        }
+        return world.getBlockId(x, y, z);
+    }
+
+    @Override
+    public Block getBlock(int x, int y, int z) {
+        return Block.getBlock(getBlockId(x, y, z));
+    }
+
+    @Override
+    public BlockEntity getBlockEntity(int x, int y, int z) {
+        ChunkCoordinates c = new ChunkCoordinates(x, y, z);
+        if (blockEntryMap.containsKey(c)){
+            return blockEntryMap.get(c).blockEntity;
+        }
+        return world.getBlockEntity(x, y, z);
+    }
+
+    @Override
+    public float getBrightness(int x, int y, int z, int blockLightValue) {
+        if (lightRefEntity != null) return lightRefEntity.getBrightness(1f);
+        return world.getBrightness(x, y, z, blockLightValue);
+    }
+
+    @Override
+    public int getLightmapCoord(int x, int y, int z, int blockLightValue) {
+        if (lightRefEntity != null) return lightRefEntity.getLightmapCoord(1f);
+        return world.getLightmapCoord(x, y, z, blockLightValue);
+    }
+
+    @Override
+    public float getLightBrightness(int x, int y, int z) {
+        return world.getLightBrightness(x, y, z);
+    }
+
+    @Override
+    public int getBlockMetadata(int x, int y, int z) {
+        ChunkCoordinates c = new ChunkCoordinates(x, y, z);
+        if (blockEntryMap.containsKey(c)){
+            return blockEntryMap.get(c).blockMeta;
+        }
+        return world.getBlockMetadata(x, y, z);
+    }
+
+    @Override
+    public Material getBlockMaterial(int x, int y, int z) {
+        Block b = getBlock(x, y, z);
+        return b == null ? Material.air : b.blockMaterial;
+    }
+
+    @Override
+    public boolean isBlockOpaqueCube(int x, int y, int z) {
+        Block b = getBlock(x, y, z);
+        return b != null && b.isSolidRender();
+    }
+
+    @Override
+    public boolean isBlockNormalCube(int x, int y, int z) {
+        Block b = getBlock(x, y, z);
+        return b != null && b.blockMaterial.isSolidBlocking() && b.renderAsNormalBlockOnCondition(this, x, y, z);
+    }
+
+    @Override
+    public double getBlockTemperature(int x, int z) {
+        return world.getBlockTemperature(x, z);
+    }
+
+    @Override
+    public double getBlockHumidity(int x, int z) {
+        return world.getBlockHumidity(x, z);
+    }
+
+    @Override
+    public SeasonManager getSeasonManager() {
+        return world.getSeasonManager();
+    }
+
+    @Override
+    public Biome getBlockBiome(int x, int y, int z) {
+        return world.getBlockBiome(x, y, z);
+    }
+
+    @Override
+    public int getSavedLightValue(LightLayer layer, int x, int y, int z) {
+        return world.getSavedLightValue(layer, x, y, z);
+    }
+    public static class BlockEntry {
+        public final int blockID;
+        public final int blockMeta;
+        @Nullable
+        public final BlockEntity blockEntity;
+        public final int x;
+        public final int y;
+        public final int z;
+        public BlockEntry(int blockID, int blockMeta, @Nullable BlockEntity blockEntity, int x, int y, int z){
+            this.blockID = blockID;
+            this.blockMeta = blockMeta;
+            this.blockEntity = blockEntity;
+            this.x = x;
+            this.y = y;
+            this.z = z;
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/Dimension.java b/src/main/java/net/minecraft/core/world/Dimension.java
index 45cdd1625..633b815a6 100644
--- a/src/main/java/net/minecraft/core/world/Dimension.java
+++ b/src/main/java/net/minecraft/core/world/Dimension.java
@@ -88,7 +88,7 @@ public class Dimension
 	{
 		if (dimensionList.containsKey(id))
 		{
-			throw new IllegalArgumentException("Dimension with ID " + dimension.id + " is already registered!");
+			throw new IllegalArgumentException("Dimension with ID " + id + " is already registered!");
 		}
 
 		dimension.id = id;
diff --git a/src/main/java/net/minecraft/core/world/ICarriable.java b/src/main/java/net/minecraft/core/world/ICarriable.java
new file mode 100644
index 000000000..f8d6873ba
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/ICarriable.java
@@ -0,0 +1,50 @@
+package net.minecraft.core.world;
+
+import com.mojang.logging.LogUtils;
+import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.util.helper.Side;
+import org.slf4j.Logger;
+
+public interface ICarriable {
+    Logger LOGGER = LogUtils.getLogger();
+    /**
+     * Called every tick an entity holds this object
+     */
+    void heldTick(World world, Entity holder);
+
+    /**
+     * Called by the entity when trying to place the held object at some position
+     * @return True if carried object could place, false otherwise
+     */
+    boolean tryPlace(World world, Entity holder, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced);
+
+    /**
+     * Called when entity stops holding the object from some external, non placement method (such as death)
+     */
+    void drop(World world, Entity holder);
+
+    /**
+     * Called before an entity tries to pick up the object
+     */
+    boolean canBeCarried(World world, Entity potentialHolder);
+
+    /**
+     * Called by an entity when attempting to pick up the object
+     */
+    ICarriable pickup(World world, Entity holder);
+
+    void writeToNBT(CompoundTag tag);
+
+    void readFromNBT(CompoundTag tag);
+
+    static ICarriable createAndLoadCarriable(Entity holder, CompoundTag tag) {
+        String type = tag.getString("type");
+        if (type.equalsIgnoreCase("blockEntity")) {
+            return BlockEntity.CarriedBlock.createAndLoadCarriedBlock(holder, tag);
+        }
+        LOGGER.warn("Could not identify carriable for type {}!", type);
+        return null;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/PortalHandler.java b/src/main/java/net/minecraft/core/world/PortalHandler.java
index 951f79909..3d70844e4 100644
--- a/src/main/java/net/minecraft/core/world/PortalHandler.java
+++ b/src/main/java/net/minecraft/core/world/PortalHandler.java
@@ -310,7 +310,7 @@ label1:
         }
         for(int j5 = 0; j5 < 4; j5++)
         {
-            world.editingBlocks = true;
+            world.noNeighborUpdate = true;
             for(int xzOffset = 0; xzOffset < 4; xzOffset++)
             {
                 for(int yOffset = -1; yOffset < 4; yOffset++)
@@ -326,7 +326,7 @@ label1:
             
             ((PortalBlock)Block.blocksList[targetPortalId]).tryToCreatePortal(world, portalX,  portalY,  portalZ);
 
-            world.editingBlocks = false;
+            world.noNeighborUpdate = false;
             for(int k6 = 0; k6 < 4; k6++)
             {
                 for(int l7 = -1; l7 < 4; l7++)
diff --git a/src/main/java/net/minecraft/core/world/World.java b/src/main/java/net/minecraft/core/world/World.java
index 3771e770b..be9cae290 100644
--- a/src/main/java/net/minecraft/core/world/World.java
+++ b/src/main/java/net/minecraft/core/world/World.java
@@ -16,7 +16,6 @@ import java.util.UUID;
 import com.mojang.logging.LogUtils;
 import com.mojang.nbt.CompoundTag;
 
-import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.enums.Difficulty;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.camera.ICamera;
@@ -106,7 +105,7 @@ public class World implements WorldSource {
     public int rainbowTicks = 0;
     public int startingRainbowTicks = 0;
     public boolean dayCanHaveRainbow = true;
-    public boolean editingBlocks = false;
+    public boolean noNeighborUpdate = false;
     private long lockTimestamp = System.currentTimeMillis();
     //protected int autosavePeriod = 40;
     public Random rand = new Random();
@@ -906,7 +905,7 @@ public class World implements WorldSource {
 
     private void notifyBlockOfNeighborChange(int x, int y, int z, int blockId)
     {
-        if(editingBlocks || isClientSide)
+        if(noNeighborUpdate || isClientSide)
         {
             return;
         }
@@ -2841,15 +2840,15 @@ public class World implements WorldSource {
         return (new PathFinder(chunkcache)).findPath(entity, i, j, k, f);
     }
 
-    public boolean isBlockProvidingPowerTo(int x, int y, int z, Side side) {
+    public boolean getDirectSignal(int x, int y, int z, Side side) {
         Block block = getBlock(x, y, z);
         if (block == null) return false;
         return block.getDirectSignal(this, x, y, z, side);
     }
 
-    public boolean isBlockGettingPowered(int x, int y, int z) {
+    public boolean hasDirectSignal(int x, int y, int z) {
         for (Side side : Side.sides){
-            if (isBlockProvidingPowerTo(
+            if (getDirectSignal(
                 x + side.getOffsetX(),
                 y + side.getOffsetY(),
                 z + side.getOffsetZ(),
@@ -2861,10 +2860,10 @@ public class World implements WorldSource {
         return false;
     }
 
-    public boolean isBlockIndirectlyProvidingPowerTo(int x, int y, int z, Side side) {
+    public boolean getSignal(int x, int y, int z, Side side) {
         Block block = getBlock(x, y, z);
         if(isBlockNormalCube(x, y, z) && block != Blocks.BLOCK_REDSTONE && block != Blocks.PUMPKIN_REDSTONE) {
-            return isBlockGettingPowered(x, y, z);
+            return hasDirectSignal(x, y, z);
         }
         if(block == null) {
             return false;
@@ -2873,9 +2872,9 @@ public class World implements WorldSource {
         return block.getSignal(this, x, y, z, side);
     }
 
-    public boolean isBlockIndirectlyGettingPowered(int x, int y, int z) {
+    public boolean hasNeighborSignal(int x, int y, int z) {
         for (Side side : Side.sides){
-            if (isBlockIndirectlyProvidingPowerTo(
+            if (getSignal(
                 x + side.getOffsetX(),
                 y + side.getOffsetY(),
                 z + side.getOffsetZ(),
diff --git a/src/main/java/net/minecraft/core/world/chunk/Chunk.java b/src/main/java/net/minecraft/core/world/chunk/Chunk.java
index fdbdec6eb..e6b4d617d 100644
--- a/src/main/java/net/minecraft/core/world/chunk/Chunk.java
+++ b/src/main/java/net/minecraft/core/world/chunk/Chunk.java
@@ -333,6 +333,7 @@ public class Chunk
         int worldZ = zPosition * CHUNK_SIZE_Z + z;
 
         world.scheduleLightingUpdate(LightLayer.Block, worldX, y, worldZ, worldX, y, worldZ);
+        world.scheduleLightingUpdate(LightLayer.Sky, worldX, y, worldZ, worldX, y, worldZ);
         lightGaps(x, z);
 
         isModified = true;
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTree.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTree.java
index b0d23c6a8..b232adf65 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTree.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTree.java
@@ -73,7 +73,7 @@ public class WorldFeatureTree extends WorldFeature
                 for(int iz = z - i3; iz <= z + i3; iz++)
                 {
                     int j4 = iz - z;
-                    if((Math.abs(l3) != i3 || Math.abs(j4) != i3 || random.nextInt(2) != 0 && j2 != 0) && !Block.solid[world.getBlockId(ix, iy, iz)])
+                    if((Math.abs(l3) != i3 || Math.abs(j4) != i3 || random.nextInt(2) != 0 && j2 != 0) && WorldFeatureTree.canLeavesReplace(world, ix, iy, iz))
                     {
                     	placeLeaves(world, ix, iy, iz, random);
                     }
@@ -121,4 +121,9 @@ public class WorldFeatureTree extends WorldFeature
     	}
     	return null;
     }
+
+    public static boolean canLeavesReplace(World world, int x, int y, int z) {
+        Block b = world.getBlock(x, y, z);
+        return b == null || b.hasTag(BlockTags.PLACE_OVERWRITES);
+    }
 }
